%define tarball xf86-video-ati
%define tptarball xf86-video-ati
%define tpver 6.12.2
%define moduledir %(pkg-config xorg-server --variable=moduledir )
%define driverdir	%{moduledir}/drivers

#%define cvsdate cvs20060404

%ifarch %{ix86} x86_64 ia64 ppc alpha sparc sparc64
%define with_dri	1
%else
%define with_dri	0
%endif

Summary:   Xorg X11 ati video driver
Name:      xorg-x11-drv-ati
Version:   6.6.3
Release:   3.27%{?dist}
URL:       http://www.x.org
License:   MIT/X11
Group:     User Interface/X Hardware Support
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Source0:   ftp://ftp.x.org/pub/individual/driver/%{tarball}-%{version}.tar.bz2
Source1:   ati.xinf
Source2:   r128.xinf
Source3:   radeon.xinf
Source4:   %{tptarball}-%{tpver}.tar.bz2
Source5:   r500.xinf

# Base FC6 section
# Radeon patches (0-99)
Patch0:	    radeon-6.6.1-dotclock-filter.patch
Patch1:	    radeon-6.6.1-use-mtdriver.patch
Patch2:     blank-on-init.patch

# Rage 128 patches (100-199)
Patch100:  r128-missing-xf86ForceHWCursor-symbol-bug168753.patch

# mach64 patches (200-299)

# ati wrapperloader patches (300-399)
Patch300: ati-prefer-radeon-then-r128.patch

# RHEL-specific customisation
# Radeon patches (1000-1999)
Patch1000: radeon-disable-dri-for-rv100.patch
Patch1001: rn50-pixel-clock-limit.patch
# bz #244980
Patch1002: radeon-6.6.3-renderaccel-buglet.patch
# bz #244614
Patch1003: radeon-6.6.3-rn50-sun-hardcoded-edid.diff
# bz #235156
Patch1004: radeon-6.6.3-disable-rmx-using-ddc-mode.patch
# bz #302871
Patch1005: radeon-6.6.3-disable-dell-rn50-rmx.patch
# bz #310331
Patch1006: radeon-6.6.3-fix-rn50-mode-hang.patch
# bz #310371
Patch1007: radeon-6.6.3-sort-modes-widescreen.patch
# bz #251159 - attempted fix for wierdness on 9600 card.
# backported upstream code
#Patch1008: radeon-6.6.3-indirect-cursor-regs.patch
# bz #274831
Patch1009: radeon-6.6.3-arima-rn50.patch
# bz #211530
Patch1010: radeon-6.6.3-disable-altix-dri.patch
# bz #448139
Patch1011: radeon-6.6.3-altix-xaa-no-offscreen-pixmaps.patch
Patch1012: radeon-6.6.3-disable-firemv-dac-load-detect.patch
# bz 465142
Patch1013: radeon-6.6.3-option-dri.patch

# Rage128 patches (2000-2999)
# mach64 patches (3000-3999)
# ati wrapperloader patches (4000-4999)
# radeon-tp (5000-5999)
Patch5000: r500-upstream-fixes.patch
Patch5001: r500-compat.patch
Patch5002: r500-disable-rotation.patch
Patch5003: r600-fix-cursor.patch

# all merged upstream
# bz #466987
#Patch5003: r500-hdmi-vga-fix.patch
# bz #469089
#Patch5004: r500-lvds-dpms.patch
#Patch5005: r500-hdmi-dac.patch

ExclusiveArch: %{ix86} x86_64 ia64 ppc alpha sparc sparc64

BuildRequires: pkgconfig
BuildRequires: autoconf automake libtool
# XXX update
BuildRequires: xorg-x11-server-sdk >= 1.1.1-48.58.el5
%if %{with_dri}
BuildRequires: mesa-libGL-devel >= 6.4-4
BuildRequires: libdrm-devel >= 2.0-1
%endif

Requires:  xorg-x11-server-Xorg >= 1.1.1-48.58.el5

%description 
X.Org X11 ati video driver.

%prep
%setup -q -n %{tarball}-%{version}

%patch0 -p1 -b .dotclock-filter
%patch1 -p1 -b .mtdriver
%patch100 -p0 -b .r128-missing-xf86ForceHWCursor-symbol-bug168753
%patch300 -p1 -b .prefer
%patch1000 -p1 -b .rv100-dri
%patch1001 -p1 -b .rn50-dotclock
%patch1002 -p1 -b .r100-renderaccel
%patch1003 -p1 -b .rn50-sun
%patch1004 -p1 -b .rn50-ibm-lewis
%patch1005 -p1 -b .rn50-rmx-dell
%patch1006 -p1 -b .rn50-mode-hang
%patch1007 -p1 -b .sort-widescreen
#patch1008 -p1 -b .indirect-regs
%patch1009 -p1 -b .rn50-arima
%patch1010 -p1 -b .disable-altix-dri
%patch1011 -p1 -b .altix-xaa
%patch1012 -p1 -b .firemv-dac
%patch1013 -p1 -b .optdri

cd ..
rm -rf %{tptarball}-%{tpver}
tar jxf %{SOURCE4}
cd %{tptarball}-%{tpver}

%patch5000 -p1 -b .r500-upstream
%patch5001 -p1 -b .r500-compat
%patch5002 -p1 -b .disable-rotation
%patch5003 -p1 -b .r600-fix-cursor
%patch1010 -p1 -b .disable-altix-dri
%patch1011 -p1 -b .altix-xaa

%build
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing $CFLAGS"
OPTS="--disable-static --libdir=%{_libdir} --mandir=%{_mandir}"
%configure --disable-static
make %{?_smp_mflags}

# r500
cd ../%{tptarball}-%{tpver}
autoreconf -v --install
./configure ${OPTS} --disable-exa
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

# radeontp
cd ../%{tptarball}-%{tpver}
make install DESTDIR=$RPM_BUILD_ROOT

cd -
make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_datadir}/hwdata/videoaliases
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{_datadir}/hwdata/videoaliases/
install -m 0644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/hwdata/videoaliases/
install -m 0644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/hwdata/videoaliases/
install -m 0644 %{SOURCE5} $RPM_BUILD_ROOT%{_datadir}/hwdata/videoaliases/

# INFO: We don't want to ship the libtool archives (*.la) from modules
# directory, as they serve no useful purpose.
find $RPM_BUILD_ROOT -regex ".*\.la$" | xargs rm -f --

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir %{moduledir}
%dir %{driverdir}
%{driverdir}/ati_drv.so
%{driverdir}/ati_r500_drv.so
%{driverdir}/ati_tp_drv.so
%{driverdir}/atimisc_drv.so
%{driverdir}/r128_drv.so
%{driverdir}/radeon_drv.so
%{driverdir}/r500_drv.so
%{driverdir}/radeon_tp_drv.so
%{_datadir}/hwdata/videoaliases/ati.xinf
%{_datadir}/hwdata/videoaliases/r128.xinf
%{_datadir}/hwdata/videoaliases/radeon.xinf
%{_datadir}/hwdata/videoaliases/r500.xinf
%dir %{moduledir}/multimedia
%{moduledir}/multimedia/theatre200_drv.so
%{moduledir}/multimedia/theatre_detect_drv.so
%{moduledir}/multimedia/theatre_drv.so
#%dir %{_mandir}/man4x
%{_mandir}/man4/ati.4*
%{_mandir}/man4/r128.4*
%{_mandir}/man4/radeon.4*

%changelog
* Thu Jul 30 2009 Dave Airlie <airlied@redhat.com> 6.6.3-3.27.el5
- fix r600 cursor issue (#514559)

* Tue May 12 2009 Adam Jackson <ajax@redhat.com> 6.6.3-3.26.el5
- Rebuild for new RANDR source (#481067)
- r500-disable-rotation.patch: Disable reflection and rotation, not expected
  to work and not enabled in the other RANDR drivers.

* Fri Apr 24 2009 Dave Airlie <airlied@redhat.com> 6.6.3-3.25.el5
- drop overlap from radeon.xinf (#483165)

* Fri Apr 24 2009 Dave Airlie <airlied@redhat.com> 6.6.3-3.24.el5
- radeon-6.6.3-option-dri.patch: add DRI option support (#465142)
- rebase r500 to 6.12.2 + backport fixes (#495098)
- r500.xinf: update with latest PCI IDs (#483165, #475532)

* Mon Dec 22 2008 Dave Airlie <airlied@redhat.com> 6.6.3-3.23.el5
- radeon-6.6.3-disable-firemv-dac-load-detect.patch: repair patch (#448139)

* Wed Dec 10 2008 Adam Jackson <ajax@redhat.com> 6.6.3-3.22
- Rebuild against new server source.

* Wed Dec 03 2008 Dave Airlie <airlied@redhat.com> 6.6.3-3.21.el5
- r500-hdmi-dac.patch: fix HDMI reporting a DAC (#466987)
- radeon-6.6.3-disable-firemv-dac-load-detect.patch (#448139)

* Wed Nov 12 2008 Dave Airlie <airlied@redhat.com> 6.6.3-3.20.el5
- r500-lvds-dpms.patch: fix lvds dpms (#469089)
- r500-hdmi-vga-fix.patch: fix shared DDC lines (#466987)
- radeon-6.6.3-altix-xaa-no-offscreen-pixmaps.patch (#448139, #468015)

* Fri Oct 17 2008 Dave Airlie <airlied@redhat.com> 6.6.3-3.19.el5
- Fix 2560x1600 displays (#464059)

* Mon Oct 06 2008 Dave Airlie <airlied@redhat.com> 6.6.3-3.18.el5
- r500-gtf.patch - link GTF into build

* Tue Sep 16 2008 Adam Jackson <ajax@redhat.com> 6.6.3-3.17.el5
- Add -fno-strict-aliasing.

* Thu Sep 11 2008 Dave Airlie <airlied@redhat.com> 6.6.3-3.15.el5
- rebase r500 driver to upstream codebase.

* Thu Sep 04 2008 Dave Airlie <airlied@redhat.com> 6.6.3-3.14.el5
- rebase onto new randr source code from server

* Fri Apr 18 2008 Dave Airlie <airlied@redhat.com> 6.6.3-3.13.el5
- fixup build to re-autoconf the makefiles to pick bits up.

* Fri Apr 18 2008 Dave Airlie <airlied@redhat.com> 6.6.3-3.12.el5
- Revert radeon-6.6.3-indirect-cursor-regs.patch (#251159)
  it didn't help the customer and we are paranoid.
- make radeon_tp compile against latest X server header files.

* Tue Jan 29 2008 Kristian Høgsberg <krh@redhat.com> - 6.6.3-3.11.el5
- Add radeon-6.6.3-disable-altix-dri.patch to disable DRI on SGI Altix
  systems and disable blank-on-init patch entirely (#211530).

* Thu Jan 17 2008 Dave Airlie <airlied@redhat.com> 6.6.3-3.10.el5
- Radeon add support for R500/R600 chipsets (#185028)

* Mon Jan 14 2008 Dave Airlie <airlied@redhat.com> 6.6.3-3.9.el5
- radeon-6.6.3-arima-rn50.patch (#274831)

* Mon Jan 14 2008 Dave Airlie <airlied@redhat.com> 6.6.3-3.8.el5
- radeon-6.6.3-indirect-cursor-regs.patch (#251159)

* Thu Dec 20 2007 Dave Airlie <airlied@redhat.com> 6.6.3-3.7.el5
- radeon-6.6.3-sort-modes-widescreen.patch (#310371)

* Thu Dec 20 2007 Dave Airlie <airlied@redhat.com> 6.6.3-3.6.el5
- radeon-6.6.3-fix-rn50-mode-hang.patch (#310331)

* Thu Dec 20 2007 Dave Airlie <airlied@redhat.com> 6.6.3-3.5.el5
- radeon-6.6.3-disable-rmx-using-ddc-mode.patch (#235156)
- radeon-6.6.3-disable-dell-rn50-rmx.patch (#302871)

* Fri Dec 07 2007 Dave Airlie <airlied@redhat.com> 6.6.3-3.4.el5
- radeon-6.6.3-rn50-sun-hardcoded-edid.diff (#244614)

* Fri Dec 07 2007 Dave Airlie <airlied@redhat.com> 6.6.3-3.3.el5
- radeon-6.6.3-renderaccel-buglet.patch (#244980)

* Fri Dec 15 2006 Adam Jackson <ajax@redhat.com> 6.6.3-3.2.el5
- blank-on-init.patch: Disable the blanking hack for mach64, it's breaking
  startup.  (#219677)
- blank-on-init.patch: Also remove redundant DRI disabling redundancy for
  the DRI-disabled RV100 (redundantly).

* Thu Dec 14 2006 Adam Jackson <ajax@redhat.com> 6.6.3-3.1.el5
- rn50-pixel-clock-limit.patch: As with RHEL3 and RHEL4, de-conflate maximum
  PLL frequency and maximum pixel clock, so the PLL paramaters calculation
  produces valid results.  Fixes black screens and lost sync. (#211504)

* Fri Dec 1 2006 Adam Jackson <ajax@redhat.com> 6.6.3-3.el5
- rn50-pixel-clock-limit.patch: Back down from overly optimistic maximum
  dotclock in upstream RN50 code. (#217666)

* Wed Nov 08 2006 Soren Sandmann <sandmann@redhat.com> 6.6.3-2.el5
- Add blank-on-init.patch, to blank the framebuffer before setting the
  initial mode. (#210297). 

* Tue Oct 17 2006 Adam Jackson <ajackson@redhat.com> 6.6.3-1.el5
- Update to 6.6.3.  (#209494)

* Thu Oct 12 2006 Adam Jackson <ajackson@redhat.com> 6.6.2-4.1.el5
- radeon-disable-dri-for-rv100.patch: Disable DRI on rv100-generation cards,
  since it's known to be unstable.  (#197992)

* Mon Oct 2 2006 Adam Jackson <ajackson@redhat.com> 6.6.2-4
- ati-prefer-radeon-then-r128.patch: When loading through the 'ati' wrapper,
  prefer radeon to rage128 to mach{64,32,16,8,4,2,1}. 
- r128-fp-dpms.patch: Hook up DPMS for Rage128 DFPs. (#197436)
- radeon-6.6.2-dac-fix.patch: Even though we turn DACs on for probing, don't
  turn them off.  Fixes black screen of death post-rhgb.  (#208610)
- radeon-6.6.2-pmac-bios.patch: Be more suspicious of ROMs before interpreting
  their content.  (#208694)
- radeon-6.6.2-usefbdev-patch.patch: Use the framebuffer stride from fbdev,
  instead of making up numbers.  (#208694)

* Sun Oct 01 2006 Jesse Keating <jkeating@redhat.com> - 6.6.2-3
- rebuilt for unwind info generation, broken in gcc-4.1.1-21

* Thu Sep 21 2006 Adam Jackson <ajackson@redhat.com> 6.6.2-2.fc6
- radeon-6.6.2-dac-fix.patch: Backport 25fa71... from git.  Turn on the DAC
  before doing CRT connection probe, otherwise we might incorrectly detect
  a CRT where there isn't one. (#202240 and others)

* Tue Aug 29 2006 Adam Jackson <ajackson@redhat.com> 6.6.2-1.fc6
- Update to 6.6.2 from upstream:
  - Mach64 stability and correctness fixes
  - Mach64 EXA support.
  - Misc bugfixes for radeon.

* Thu Aug 24 2006 Adam Jackson <ajackson@redhat.com> 6.6.1-11.fc6
- radeon-6.6.1-use-mtdriver.patch: Only flag modes with M_T_PREFERRED if
  the EDID blocks says to.

* Fri Aug 18 2006 Adam Jackson <ajackson@redhat.com> 6.6.1-10.fc6
- radeon-6.6.1-use-mtdriver.patch: Use new M_T_DRIVER mode type for mode
  synthesis.
- Bump Requires to match.

* Fri Aug 18 2006 Adam Jackson <ajackson@redhat.com> 6.6.1-9.fc6
- mach64-cpio-for-ia64.patch: Enable CPIO for mach64 on ia64. (#203017)

* Thu Aug 10 2006 Adam Jackson <ajackson@redhat.com> 6.6.1-8.fc6
- radeon-6.6.1-xpress-200.patch: Also disable DRI on xpress200, known broken.

* Wed Aug  2 2006 Adam Jackson <ajackson@redhat.com> 6.6.1-7.fc6
- Make sure DRI and Render accel are disabled on RN50.

* Sat Jul 29 2006 Kristian Høgsberg <krh@redhat.com> 6.6.1-6.fc5.aiglx
- Build for fc5 aiglx repo.

* Thu Jul 27 2006 Adam Jackson <ajackson@redhat.com> 6.6.1-6.fc6
- Updated radeon.xinf: comments, a handful of new devices.

* Mon Jul 24 2006 Mike A. Harris <mharris@redhat.com> 6.6.1-5.fc6
- Added r128-missing-xf86ForceHWCursor-symbol-bug168753.patch to fix (#168753)
- Add {?dist} tag to Release field

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> 6.6.1-4.1
- rebuild

* Wed Jun 28 2006 Mike A. Harris <mharris@@redhat.com> 6.6.1-4
- Added "BuildRequires: xorg-x11-server-sdk >= 1.1.0-12" to fix the same
  problem at build time as were added in 6.6.1-2 to fix it at runtime.

* Tue Jun 27 2006 Kristian Høgsberg <krh@redhat.com> 6.6.1-3
- Bump release for FC5 aiglx build.

* Mon Jun 26 2006 Adam Jackson <ajackson@redhat.com> 6.6.1-2
- Filter the EDID mode list by the monitor's reported pixel clock.  Bump
  the BuildReq to a server that provides the necessary ABI field.

* Sat Jun 17 2006 Mike A. Harris <mharris@redhat.com> 6.6.1-1
- Updated xorg-x11-drv-ati to version 6.6.1 update release for X11R7.1
- Drop db-root-visual.patch, as it is included in 6.6.1
- Enable DRI support for sparc/sparc64 builds.

* Fri Jun  9 2006 Kristian Høgsberg <krh@redhat.com> 6.6.0-7
- Committed db-root-visual.patch and reenabled.

* Thu Jun  8 2006 Mike A. Harris <mharris@@redhat.com> 6.6.0-6
- Disable db-root-visual.patch, because the file wasn't committed to CVS.

* Thu Jun  8 2006 Kristian Høgsberg <krh@redhat.com> 6.6.0-5
- Bump for rawhide build.

* Thu Jun  8 2006 Kristian Høgsberg <krh@redhat.com> 6.6.0-4
- Add db-root-visual.patch to make root visual double buffered.

* Tue May 23 2006 Adam Jackson <ajackson@redhat.com> 6.6.0-3
- Rebuild for 7.1 ABI fix.

* Tue Apr 11 2006 Kristian Høgsberg <krh@redhat.com> 6.6.0-2
- Bump for fc5-bling build.

* Sun Apr  9 2006 Adam Jackson <ajackson@redhat.com> 6.6.0-1
- Update to 6.6.0 from 7.1RC1.

* Tue Apr  4 2006 Kristian Høgsberg <krh@redhat.com> 6.5.7.3-4.cvs20060404
- Update to CVS snapshot from 20060404.

* Wed Mar 22 2006 Kristian Høgsberg <krh@redhat.com> 6.5.7.3-4.cvs20060322
- Update to CVS snapshot of 20060322.
- Drop xorg-x11-drv-ati-6.5.7.3-radeon-metamodes-SEGV-fix.patch.

* Tue Feb 21 2006 Mike A. Harris <mharris@redhat.com> 6.5.7.3-4
- Added xorg-x11-drv-ati-6.5.7.3-radeon-metamodes-SEGV-fix.patch from CVS HEAD.

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 6.5.7.3-3.2
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 6.5.7.3-3.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Sun Feb 05 2006 Mike A. Harris <mharris@redhat.com> 6.5.7.3-3
- Updated radeon.xinf to be up to date with the xf86PciInfo.h from the Xorg
  X server 1.0.1-1 source.  This should account for all supported Radeon
  models now modulo errors/omissions.

* Thu Feb 02 2006 Mike A. Harris <mharris@redhat.com> 6.5.7.3-2
- Added r128.xinf and radeon.xinf videoalias files to fix bug (#174101).
- Added "BuildRequires: libdrm-devel >= 2.0-1" to fix bug (#178613)

* Wed Jan 18 2006 Mike A. Harris <mharris@redhat.com> 6.5.7.3-1
- Updated xorg-x11-drv-ati to version 6.5.7.3 from X11R7.0
- Added ati.xinf videoalias file for hardware autodetection.

* Tue Dec 20 2005 Mike A. Harris <mharris@redhat.com> 6.5.7.2-1
- Updated xorg-x11-drv-ati to version 6.5.7.2 from X11R7 RC4
- Removed 'x' suffix from manpage dirs to match RC4 upstream.

* Wed Nov 16 2005 Mike A. Harris <mharris@redhat.com> 6.5.7-1
- Updated xorg-x11-drv-ati to version 6.5.7 from X11R7 RC2

* Fri Nov 4 2005 Mike A. Harris <mharris@redhat.com> 6.5.6.1-1
- Updated xorg-x11-drv-ati to version 6.5.6.1 from X11R7 RC1
- Fix *.la file removal.
- Add "BuildRequires: mesa-libGL-devel >= 6.4-4 for DRI builds"

* Mon Oct 3 2005 Mike A. Harris <mharris@redhat.com> 6.5.6-1
- Update BuildRoot to use Fedora Packaging Guidelines.
- Deglob file manifest.
- Use _smp_mflags with make, to speed up SMP builds.
- Add "alpha sparc sparc64" to ExclusiveArch

* Fri Sep 2 2005 Mike A. Harris <mharris@redhat.com> 6.5.6-0
- Initial spec file for ati video driver generated automatically
  by my xorg-driverspecgen script.
